require 'class'
require 'utils'

Map = class()

Map.init = function(self, s)
	local s = s or ''
	local t = {}
	local j
	local ss = s:split('\n')
	local maxj = 0

	local firstLine = ss[1]:split(' ')

	self.goal = tonumber(firstLine[1])
	self.next = tostring(firstLine[2])
	self.next = self.next:sub(1,#self.next-1)

	for i_ = 2, #ss do
		local i = i_-1
		t[i] = {}
		j = 1
		for c in ss[i_]:gmatch('.') do
			if c == '#' then
				t[i][j] = 'brick'
			elseif c == '@' then
				self.startx = j
				self.starty = i
				t[i][j] = 'grass'
			else
				t[i][j] = 'grass'
			end

			j = j + 1
		end
		if j-1 > maxj then
			maxj = j-1
		end
	end

	self.t = t
	self.width = maxj - 1
	self.height = #ss - 1

	local t_ = {}
	for x = 1, self.width do
		t_[x] = {}
		for y = 1, self.height do
			t_[x][y] = t[y][x]
		end
	end

	self.t = t_
--~ 	print('map', maxj, #ss)
end
