require 'class'

local isDown = love.keyboard.isDown

Controller = class()

Controller.init = function(self, engine)
	self.engine = engine
end

Controller.update = function(self, dt)
	local new_direction
	local e = self.engine
	local dir = self.engine.direction

	if e.alcohol_counter == 0 then

		if (isDown('w') or isDown('up')) and dir ~= 'down' then
			new_direction = 'up'
		elseif (isDown('d') or isDown('right')) and dir ~= 'left' then
			new_direction = 'right'
		elseif (isDown('s') or isDown('down')) and dir ~= 'up' then
			new_direction = 'down'
		elseif (isDown('a') or isDown('left')) and dir ~= 'right' then
			new_direction = 'left'
		end

	else

		if (isDown('s') or isDown('down')) and dir ~= 'down' then
			new_direction = 'up'
		elseif (isDown('a') or isDown('left')) and dir ~= 'left' then
			new_direction = 'right'
		elseif (isDown('w') or isDown('up')) and dir ~= 'up' then
			new_direction = 'down'
		elseif (isDown('d') or isDown('right')) and dir ~= 'right' then
			new_direction = 'left'
		end

	end

	if new_direction then
		if new_direction == self.engine.direction then
			self.engine.counter = self.engine.counter + self.engine.acceleration*dt
		else
			self.engine.next_direction = new_direction
		end
	end
end
