require 'utils'

--~ local sheet = love.filesystem.read('sheet.xml')
local lines = love.filesystem.lines

local parse = function(s)
	return s:sub(s:find('"')+1, s:find('"', s:find('"')+1)-1)
end

local imagescache = {quads={}}

--~ for line in sheet:lines() do
for line in lines('sheet.xml') do
	local s, e, _
	if not imagescache.path then
		s, e = line:find('<sprite file="')
		if s and e then
			local x = line:find('"', line:find('"')+1)
			imagescache.path = line:sub(e+1, x-1)
		end
	else
		_, s = line:find('<frame ')
		e = line:find(' />')
		if s and e then
			local t = line:sub(s+1, e-1):split(' ')
			imagescache.quads[parse(t[1])] = {tonumber(parse(t[2])),
				tonumber(parse(t[3])),
				tonumber(parse(t[4])),
				tonumber(parse(t[5]))}
		end
	end
end

return imagescache
